Package: synlet
Type: Package
Title: Hits Selection for Synthetic Lethal RNAi Screen Data
Version: 2.12.0
Authors@R: person(given = "Chunxuan", family = "Shao", role = c("aut", "cre"), email = "chunxuan@outlook.com")
Description: Select hits from synthetic lethal RNAi screen data. For
        example, there are two identical celllines except one gene is
        knocked-down in one cellline. The interest is to find genes
        that lead to stronger lethal effect when they are knocked-down
        further by siRNA. Quality control and various visualisation
        tools are implemented. Four different algorithms could be used
        to pick up the interesting hits. This package is designed based
        on 384 wells plates, but may apply to other platforms with
        proper configuration.
License: GPL-3
biocViews: ImmunoOncology, CellBasedAssays, QualityControl,
        Preprocessing, Visualization, FeatureExtraction
Imports: data.table, ggplot2, grDevices, magrittr, methods, patchwork,
        RankProd, RColorBrewer, stats, utils
Suggests: BiocStyle, knitr, testthat, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: no
RoxygenNote: 7.2.3
Encoding: UTF-8
Config/pak/sysreqs: libgmp3-dev libmpfr-dev
Repository: https://bioc-release.r-universe.dev
Date/Publication: 2026-04-28 12:41:40 UTC
RemoteUrl: https://github.com/bioc/synlet
RemoteRef: RELEASE_3_23
RemoteSha: 3231d1e8dad1ec3b4d385261f9b5848fc9ea00df
Packaged: 2026-04-30 06:54:56 UTC; root
Author: Chunxuan Shao [aut, cre]
Maintainer: Chunxuan Shao <chunxuan@outlook.com>
Depends: R (>= 3.5.0)
Built: R 4.6.0; ; 2026-04-30 08:04:15 UTC; unix

#' @import data.table
#' @import ggplot2
#' @import patchwork
#' @importFrom magrittr %>% set_rownames set_colnames set_names set_rownames extract inset
#' @importFrom grDevices colorRampPalette rainbow
#' @importFrom methods is
#' @importFrom utils write.table
#' @importFrom stats mad median medpolish na.omit p.adjust phyper sd t.test
NULL

#- deal with . in magrittr
if(getRversion() >= "2.15.1")  utils::globalVariables(c("."))

#' student's t-test on B-score
#'
#' Select hits by student's t-test using B-score from treatment and control plates.
#'
#' @param mtx b-score matrix.
#' @param n_treat number of treatment plates
#' @param n_cont number of control plates
#' @return A list containing student's t-test for each master plate
#' \itemize{
#'   \item pvalue: p-value of the t-test
#'   \item Treat_Cont: difference in bscore: treatment - control
#'   \item p_adj: BH adjusted p-value
#' }
#' @references
#' Birmingham, A. et al. Statistical methods for analysis of high-throughput RNA interference screens. Nat Methods 6, 569-575 (2009).
#' @examples
#' data(example_dt)
#' bscore_res <- sapply(unique(example_dt$MASTER_PLATE), bScore,
#'   example_dt, control = "control", treatment = "treatment", simplify = FALSE)
#' tTest(bscore_res$P001, 3, 3)
#' @export
tTest <- function(mtx, n_treat, n_cont) {
  mtx <- mtx[grep("empty", rownames(mtx), invert = TRUE), ]

  res    <- t(apply(mtx, 1, .ff_ttest, n_treat, n_cont))
  res_na <- res[is.na(res[, "pvalue"]), ]

  if (nrow(res_na) != 0) {
    message("(II) NA generated for following siRNAs in t-test.")
    for (siRNA in rownames(res_na)) {
      message(siRNA, "\n")
    }
  }

  res <- res[!is.na(res[, "pvalue"]), ]

  #- replace number with column names.
  if (nrow(res) != 0) {
    res <- cbind(res, p_adj = p.adjust(res[, "pvalue"], "BH"))
  } else {
    message("(II) No valid t-test.")
  }

  return(res)
}

#' @keywords internal
.ff_ttest <- function(x, n_treat, n_cont) {
  # browser()
  cond <- factor(rep(c("treatment", "control"), times = c(n_treat, n_cont)), levels = c("treatment", "control"))
  dta  <- data.frame(value = x, cond = cond)

  res <- try(t.test(value ~ cond, data = dta), silent = TRUE)

  if (is(res, "try-error")) {
    p <- NA
    v <- NA
  } else {
    p <- res$"p.value"
    m <- tapply(dta$value, dta$cond, mean, na.rm = TRUE)
    v <- m[1] - m[2]
  }

  t_res <- c(p, v) %>% set_names(c("pvalue", "Treat_Cont"))
  return(t_res)
}

context("Test output of bscore and t-test")

test_that("b-score is correctly calculated", {
  res <- sapply("P001", bScore, example_dt, control = "control",
                       treatment = "treatment", simplify = FALSE)
  res_1 <- res$P001
  expect_equal(as.numeric(res_1[1, ]), c(-0.379059117,  1.4344181, -0.8484694,
                                         -0.1088711, -1.14224946, -0.0854374), tolerance = 1e-3)
  ttest_res  <- tTest(res_1, 3, 3)
  expect_equal(as.numeric(ttest_res[1, ]), c(0.55670002,  0.51448255, 0.8761181), tolerance = 1e-3)
})

#' Scatter plot of RNAi screen results
#'
#' Produce a single plot for readous of each plate, with the option of highlighting
#' specific signals, like positive/negative controls.
#'
#' @param dta synthetic lethal RNAi screen data
#' @param scatter_colour colour for different signals
#' @param controlOnly whether or not to plot control wells only
#' @param control_name names of control siRNAs.
#' @return a ggplot object
#' @examples
#' data(example_dt)
#' scatterPlot(example_dt, control_name = c("PLK1 si1", "scrambled control si1", "lipid only"))
#' @export
scatterPlot <- function(dta, scatter_colour = rainbow(10), controlOnly = FALSE, control_name = NULL) {
  new_cond <- WELL_CONTENT_NAME <- EXPERIMENT_MODIFICATION <- new_name <- PLATE <- READOUT <- NULL

  dta_2 <- copy(dta)

  if (controlOnly == FALSE) {
    if (is.null(control_name)) {
      message("(II) Better to provide names for positive/negative controls.")
      dta_2[, new_cond := "knock-down signals"]
    } else {
      dta_2[, new_cond := WELL_CONTENT_NAME] %>%
        .[!(WELL_CONTENT_NAME %in% control_name), new_cond := "knock-down signals"]
    }
  } else {
    if (is.null(control_name)) {
      stop("(EE) Please provide names for positive/negative controls if controlOnly is TRUE.")
    } else {
      dta_2 <- dta_2[WELL_CONTENT_NAME %in% control_name][, new_cond := WELL_CONTENT_NAME]
    }
  }

  dta_2 <- dta_2[order(EXPERIMENT_MODIFICATION)] %>%
    .[, new_name := paste(PLATE, EXPERIMENT_MODIFICATION, sep = " ") %>% factor]

  ggplot(as.data.frame(dta_2), aes(new_name, READOUT, colour = new_cond)) +
    geom_point() +
    theme_bw(14) +
    theme(panel.grid.major     = element_blank(),
          panel.grid.minor     = element_blank(),
          panel.background     = element_rect(colour = "black", size = 1),
          axis.title           = element_text(face = "bold"),
          axis.text.x          = element_text(angle = -90, hjust = 0),
          legend.position      = c(1, 1),
          legend.title         = element_blank(),
          legend.justification = c(1, 1)) +
    labs(x = "", y = "READOUTS\n") +
    scale_colour_manual(values = scatter_colour)
}

#' Plot siRNA data and quality metrics.
#'
#' Plot the normalized RNAi screen data, row data, control signals and Z' factor.
#'
#' @param gene gene symbol, case sensitive
#' @param dta synthetic lethal RNAi screen data
#' @param controlsiRNA controlsiRNA could be a vector of several siRNA, including postive/negative control
#' @param FILEPATH path to store the figure
#' @param colour colour used in graphs
#' @param zPrimeMed zPrime factor basing on median
#' @param zPrimeMean, zPrime factor basing on mean
#' @param treatment the treatment condition in EXPERIMENT_MODIFICATION
#' @param control the control condition in EXPERIMENT_MODIFICATION
#' @param normMethod could be a PLATE and negative controls
#' @param save_plot whether save a png file in the working directory.
#' @param width width of the plot
#' @param height height of the plot
#' @return Return the ggplot2 objects in a list, which could be plotted individually.
#' @examples
#' data(example_dt)
#' zF_mean <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1")
#' zF_med  <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1",
#'                    useMean = FALSE)
#' p01 <- siRNAPlot("AAK1", example_dt,
#'                  controlsiRNA = c("lipid only", "scrambled control si1"),
#'                  FILEPATH = ".",  zPrimeMed = zF_med, zPrimeMean = zF_mean,
#'                  treatment = "treatment", control = "control",
#'                  normMethod = c("PLATE", "lipid only", "scrambled control si1"))
#' @export
#- Need to generate a plot.
siRNAPlot <- function(gene,
    dta,
    controlsiRNA,
    FILEPATH = ".",
    colour   = rainbow(10),
    zPrimeMed,
    zPrimeMean,
    treatment,
    control,
    normMethod = c("PLATE"),
    save_plot  = FALSE,
    width      = 15,
    height     = 14) {
  ## controlsiRNA could be a vector of several siRNA, including postive/negative control;
  ## zPrimeMed, zPrime factor basing on median;
  ## zPrimeMean, zPrime factor basing on mean;
  ## normMethod could be a PLATE and negative controls;
  ## Z factor plots, raw data plots and control plots.
  WELL_CONTENT_NAME <- PLATE <- READOUT <- MASTER_PLATE <- rn <- value <- variable <- siRNA <- experiments <- NULL

  message("(==) Processing: ", gene, "\n")

  ex_match <- paste("^", gene, " ", sep = "")

  if (length(grep(ex_match, dta$WELL_CONTENT_NAME)) == 0) {
    message("(II) ", gene, " not found!\n")
  } else {
    dta_2 <- dta[grep(ex_match, WELL_CONTENT_NAME), c("PLATE", "MASTER_PLATE", "WELL_CONTENT_NAME", "EXPERIMENT_MODIFICATION", "READOUT")] %>%
      .[, PLATE := factor(PLATE)]

    #- Raw siRNA barplots.
    p_raw_barpl <- ggplot(as.data.frame(dta_2), aes( WELL_CONTENT_NAME, READOUT, fill = PLATE)) +
      geom_bar(stat = "identity", position = "dodge") +
      facet_grid(~ EXPERIMENT_MODIFICATION) +
      theme_bw(14) +
      theme(panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.background = element_rect(colour = "black", size = 1),
            axis.text.x      = element_text(angle = -90, hjust = 0),
            legend.title     = element_blank()) +
      scale_fill_manual(values = colour) +
      labs(x = "", y = "raw readouts", title = "Barplot of raw screen readouts")

    dta_3 <- dta[MASTER_PLATE == unique(dta_2$MASTER_PLATE)] %>%
      .[WELL_CONTENT_NAME %in% controlsiRNA] %>%
      .[, PLATE := factor(PLATE)]

    p_cont_boxplot <- ggplot(as.data.frame(dta_3), aes(WELL_CONTENT_NAME, READOUT, fill = PLATE)) +
      geom_boxplot() +
      facet_grid(~ EXPERIMENT_MODIFICATION) +
      theme_bw(14) +
      theme(panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.background = element_rect(colour = "black", size = 1),
            axis.text.x      = element_text(angle = -45, hjust = 0),
            legend.title     = element_blank()) +
      scale_fill_manual(values = colour) +
      labs(x = "", y = "raw readouts", title = "Boxplot of raw control readouts")

    z_med  <- zPrimeMed[as.character(unique(dta_2$PLATE)), ]
    z_mean <- zPrimeMean[as.character(unique(dta_2$PLATE)), ]
    z_comb <- cbind(z_med[, 2], z_mean[, 2]) %>%
      set_rownames(rownames(z_med)) %>%
      set_colnames(c("zPrimeF_median", "zPrimeF_mean")) %>%
      as.data.table(keep.rownames = TRUE) %>%
      #- Set the var.
      melt(measure.vars = c("zPrimeF_median", "zPrimeF_mean"))

    #- Z primer plots.
    p_zprimer_barpl <- ggplot(as.data.frame(z_comb), aes(rn, value, fill = rn)) +
      geom_bar(stat = "identity", position = "dodge") +
      facet_grid(~ variable) +
      theme_bw(14) +
      theme(panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            panel.background = element_rect(colour = "black", size = 1),
            axis.text.x      = element_text(angle = -90, hjust = 0),
            legend.title     = element_blank()) +
      scale_fill_manual(values = colour) +
      labs(x = "", y = "Z' factor", title = "Barplot of Z' factor")

    master_norm <- sapply(normMethod,
                          function(X) .ff_masterPlateValue(unique(dta_2$MASTER_PLATE),
                                                           dta,
                                                           treatment,
                                                           control,
                                                           normMethod = X), simplify = FALSE)
    n_treat_plate <- master_norm[[1]]$n_treat_plate
    n_cont_plate  <- master_norm[[1]]$n_cont_plate
    master_norm_c <- do.call(rbind,lapply(names(master_norm),
                                          function(x) data.frame(siRNA       = rownames(master_norm[[x]][[1]]),
                                                                 norMethod   = x,
                                                                 master_norm[[x]][[1]],
                                                                 check.names = FALSE)))

    dta_4 <- master_norm_c[grep(ex_match, master_norm_c$siRNA), ] %>%
      droplevels %>%
      as.data.table %>%
      setnames(2 + seq_len(n_treat_plate + n_cont_plate), paste(rep(c("treament", "control"), times = c(n_treat_plate, n_cont_plate)),
                                                                names(.)[2 + seq_len(n_treat_plate + n_cont_plate)],
                                                                sep = "__")) %>%
      melt(measure.vars = names(.)[-c(1:2)]) %>%
      .[, c("experiments", "plates") := tstrsplit(variable, split = "__")]

    #- box plot
    p_norm_boxpl <- ggplot(as.data.frame(dta_4), aes(siRNA, value, fill = experiments)) +
      geom_boxplot() +
      theme_bw() +
      theme(panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            axis.text.x      = element_text(angle = -45, hjust = 0),
            legend.title     = element_blank(),
            panel.background = element_rect(colour = "black", size = 1)) +
      geom_hline(yintercept = 1, linetype = "dashed") +
      facet_grid( ~ norMethod) +
      scale_fill_manual(values = colour) +
      labs(x ="", y = "Normalized Value", title = "Boxplot of normalized value")

    #- bar plot
    p_norm_barpl <- ggplot(as.data.frame(dta_4), aes(siRNA, value, fill = experiments)) +
      geom_bar(stat = "identity", position = "dodge") +
      theme_bw() +
      theme(panel.grid.major = element_blank(),
            panel.grid.minor = element_blank(),
            axis.text.x      = element_text(angle = -45, hjust = 0),
            legend.title     = element_blank(),
            panel.background = element_rect(colour = "black", size = 1)) +
      geom_hline(yintercept = 1, linetype = "dashed") +
      facet_grid(plates ~ norMethod) +
      scale_fill_manual(values = colour) +
      labs(x ="", y = "Normalized Value", title = "Barplot of normalized value")

    q01 <- (p_norm_boxpl | p_norm_barpl) / (p_raw_barpl | p_cont_boxplot | p_zprimer_barpl)

    if (save_plot) ggsave(file.path(FILEPATH, paste(gene, "pdf", sep = ".")), q01, width = width, height = height)

    return(list(full_plot       = q01,
                p_norm_boxpl    = p_norm_boxpl,
                p_norm_barpl    = p_norm_barpl,
                p_raw_barpl     = p_raw_barpl,
                p_cont_boxplot  = p_cont_boxplot,
                p_zprimer_barpl = p_zprimer_barpl))

  }
}

#' Select hits by the rank product method
#'
#' Select hits by rank product methods by comparing treatment and control.
#'
#' @param masterPlate the master plate to be analyzed
#' @param dta synthetic lethal RNAi screen data
#' @param treatment the treatment condition in EXPERIMENT_MODIFICATION
#' @param control the control condition in EXPERIMENT_MODIFICATION
#' @param normMethod normalization methods to be used. If "PLATE", the raw readouts are normalized by plate median, otherwise use provided control siRNA
#' @return A list contains results by the rank product method for each master plate.
#' \itemize{
#'   \item MASTER_PLATE: location of siRNA
#'   \item pvalue_treat_lowerthan_cont: p-value for the hypothesis that treatment has lower normalized readout compared to control
#'   \item FDR_treat_lowerthan_cont: FDR value
#'   \item treat_cont_log2FC: log2 fold change of treatment / control
#' }
#' @references
#' Breitling, R., Armengaud, P., Amtmann, A. & Herzyk, P. Rank products: a simple, yet powerful, new method to detect differentially regulated genes in replicated microarray experiments. FEBS Lett 573, 83-92 (2004).
#' Hong, F. et al. RankProd: a bioconductor package for detecting differentially expressed genes in meta-analysis. Bioinformatics 22, 2825-2827 (2006).
#' @examples
#' data(example_dt)
#' res <- sapply(unique(example_dt$MASTER_PLATE),
#'               rankProdHits,
#'               example_dt,
#'               control   = "control",
#'               treatment = "treatment",
#'               simplify  = FALSE)
#' @export
rankProdHits <- function(masterPlate, dta, treatment, control, normMethod = "PLATE") {
  norm_res      <- .ff_masterPlateValue(masterPlate, dta, treatment, control, normMethod = normMethod)
  masterp_dta   <- norm_res[[1]]
  n_treat_plate <- norm_res[[2]]
  n_cont_plate  <- norm_res[[3]]

  siRNA_cl   <- rep(c(0, 1), times = c(n_treat_plate, n_cont_plate))
  siRNA_rp   <- RankProd::RP(masterp_dta, siRNA_cl, logged = FALSE)
  masterp_rp <- data.frame(MASTER_PLATE                = masterPlate,
                           pvalue_treat_lowerthan_cont = siRNA_rp$pval[, 1],
                           FDR_treat_lowerthan_cont    = siRNA_rp$pfp[, 1],
                           treat_cont_log2FC           = log2(siRNA_rp$AveFC[, 1]))
  return(masterp_rp)
}

#' Select hits by RSA
#'
#' Selected hits by redundant siRNA activity method. Here is a wrapper function of RSA 1.8 by Yingyao Zhou.
#'
#' @param dta synthetic lethal RNAi screen data
#' @param treatment the treatment condition in EXPERIMENT_MODIFICATION
#' @param control the control condition in EXPERIMENT_MODIFICATION
#' @param normMethod normalization methods. If "PLATE", then values are normalized by plate median, otherwise use the
#' provided control siRNA
#' @param LB Low bound
#' @param UB up bound
#' @param revHits reverse hit picking, default the lower the score the better
#' @param Bonferroni conceptually useful when there are different number of siRNAs per gene, default FALSE
#' @param outputFile output file name
#' @param scoreFile name of the score file to be written under the current folder
#' @return A result file written to the current folder.
#' \itemize{
#'   \item Gene_ID,Well_ID,Score: columns from input spreadsheet
#'   \item LogP: OPI p-value in log10, i.e., -2 means 0.01
#'   \item OPI_Hit: whether the well is a hit, 1 means yes, 0 means no
#'   \item #hitWell: number of hit wells for the gene
#'   \item #totalWell: total number of wells for the gene. If gene A has three wells w1, w2 and w3, and w1 and w2 are hits, #totalWell should be 3, #hitWell should be 2, w1 and w2 should have OPI_Hit set as 1 and w3 should have OPI_Hit set as 0.
#'   \item OPI_Rank: ranking column to sort all wells for hit picking
#'   \item Cutoff_Rank: ranking column to sort all wells based on Score in the simple activity-based method
#' }
#' Note: a rank value of 999999 means the well is not a hit
#' @references
#' Koenig, R. et al. A probability-based approach for the analysis of large-scale RNAi screens. Nat Methods 4, 847-849 (2007).
#' @examples
#' data(example_dt)
#' rsaHits(example_dt, treatment = "treatment", control = "control",
#'         normMethod = "PLATE", LB = 0.2, UB = 0.8, revHits = FALSE,
#'         Bonferroni = FALSE, outputFile = "RSAhits.csv")
#' @export
rsaHits <- function(dta,
    treatment,
    control,
    normMethod = "PLATE",
    LB,
    UB,
    revHits    = FALSE,
    Bonferroni = FALSE,
    outputFile = "RSAhits.csv",
    scoreFile  = "RSA_score.csv") {
  tem.1 <- sapply(unique(as.character(dta$MASTER_PLATE)), .ff_rsaRatio, dta, treatment, control, normMethod = normMethod, simplify = FALSE)
  rsaScore <- data.frame(do.call(rbind, lapply(names(tem.1), function(x) tem.1[[x]])))
  write.table(rsaScore, scoreFile, sep = "\t", quote = FALSE, row.names = FALSE)

  opts <- list(LB = LB, UB = UB, outputFile = outputFile, reverse = revHits, bonferroni = Bonferroni)
  rsaRes <- OPI(rsaScore$Gene_ID, rsaScore$Score, opts, rsaScore)
  message("File written to:", outputFile)
  write.table(rsaRes, outputFile, sep = "\t", quote = FALSE, row.names = FALSE)

  message("Summary of RSA:")
  message(paste("Total #Genes = ", length(unique(rsaRes$Gene_ID)), collapse = ""));
  message(paste("Total #Wells = ", nrow(rsaRes), collapse = ""));
  message(paste("Total #Hit Genes = ", length(unique(rsaRes$Gene_ID[rsaRes$OPI_Rank < 999999])), collapse = ""));
  message(paste("Total #Hit Wells = ", sum(rsaRes$OPI_Rank < 999999), collapse = ""));
}

#' @keywords internal
handleOneGroup <- function(i, dataset, optsb, t.rank = NULL) {
  #- i is a vector with the position info in the sorted data.
  ## how many of them are up or low than cut-off.
  if (optsb$reverse) {
    i_max <- sum(dataset$Score[i] >= optsb$LB)
    i_min <- max(1, sum(dataset$Score[i] >= optsb$UB))
  } else {
    i_max <- sum(dataset$Score[i] <= optsb$UB)
    i_min <- max(1, sum(dataset$Score[i] <= optsb$LB))
  }

  ## t.r is the true rank, instead of order.
  if (is.null(t.rank)) {
    t.r <- i
  } else {
    t.r <- t.rank[i]
  }

  r <- OPIScore(t.r, nrow(dataset), i_min, i_max, optsb$bonferroni)

  return(cbind(LogP = r["logp"], OPI_Hit = as.numeric(seq(length(i)) <= r["cutoff"]), "#hitWell" = i_max, "#totalWell" = length(i), rank = i))
}

#' @keywords internal
OPIScore <- function(I_rank, N, i_min = 1, i_max = -1, bonferroni = FALSE) {
  #- Number of total siRNA for a gene.
  #- I_rank has the rank info of the siRNA to a gene.
  n_drawn <- length(I_rank)

  if (i_max == -1) {
    i_max <- n_drawn
  }

  r1 <- c(logp = 1, cutoff = 0)

  if (i_max < i_min) return(r1)

  best_logp <- 1
  cutoff    <- 0

  for (i in i_min:i_max) {
    #- Dealing with tie?
    if (i < i_max && I_rank[i] == I_rank[i + 1]) {
      next
    }

    #- i - 1, overlapping; I_rank[i], white ball; N - I_rank[i], black balls.
    logp <- phyper(i - 1, I_rank[i], N - I_rank[i], n_drawn, lower.tail = FALSE, log.p = TRUE)
    logp <- max(logp / log(10), -100)

    if (logp <= best_logp) {
      best_logp <- logp
      cutoff    <- i
    }
  }

  if (bonferroni) {
    best_logp <- best_logp + log(i_max - i_min + 1) / log(10)
  }

  return (c(logp = best_logp, cutoff = cutoff))
}

#' @keywords internal
OPI <- function(Groups, Scores, opts, Data = NULL) {
  t <- data.frame(cbind(Gene_ID = Groups, Score = Scores))
  Sorted_Order <- order(t$Score, decreasing = opts$reverse)
  Data <- Data[Sorted_Order, ]
  t <- t[Sorted_Order, ]

  ## get the ranks, "max" for the tie.
  t.rank <- rank(t$Score, ties.method = "max")
  #- Same genes are extracted in tapply.
  t <- do.call("rbind", tapply(seq(nrow(t)), list(t$Gene_ID), handleOneGroup, dataset = t, opts, t.rank))
  t <- cbind(Data, t[order(t[, "rank"]), ])

  # add OPI_Rank
  t <- t[order(t$LogP, t$Score * ifelse(opts$reverse, -1, 1)), ]
  t$OPI_Rank <- cumsum(t$OPI_Hit)
  t$OPI_Rank[t$OPI_Hit == 0] <- 999999

  # add Cutoff_Rank
  t <- t[order(t$Score * (ifelse(opts$reverse, -1, 1)), t$LogP), ]

  if (opts$reverse) {
    tmp <- (t$Score >= opts$LB)
  } else {
    tmp <- (t$Score <= opts$UB)
  }

  t$Cutoff_Rank <- cumsum(tmp)
  t$Cutoff_Rank[!tmp] <- 999999

# add EXP_Rank
  t$EXP_Rank <- pmin(t$OPI_Rank, t$Cutoff_Rank)
  t$EXP_Rank <- pmin(t$OPI_Rank, t$Cutoff_Rank)

  if (opts$reverse) {
    return(t[order(t$OPI_Rank, -t$Score), ])
  } else {
    return(t[order(t$OPI_Rank, t$Score), ])
  }
}

#' @keywords internal
.ff_rsaRatio <- function(masterPlate, dta, treatment, control, normMethod) {
  norm_res      <- .ff_masterPlateValue(masterPlate, dta, treatment, control, normMethod = normMethod)
  masterp_dta   <- norm_res[[1]]
  n_treat_plate <- norm_res[[2]]

  plate_ratio <- apply(masterp_dta, 1, .ff_ratio_rsa, n_treat_plate, n_treat_plate + 1)
  genes       <- sapply(as.character(names(plate_ratio)), function(x) unlist(strsplit(x," "))[[1]])
  rsaScore    <- data.frame(Gene_ID = genes, Well_ID = names(plate_ratio), Score = plate_ratio)

  rownames(rsaScore) <- NULL
  return(rsaScore)
}

#' @keywords internal
.ff_ratio_rsa <- function(x, y, z) {
  x <- as.numeric(x)
  a <- length(x)
  round(median(x[1:y], na.rm = TRUE) / median(x[z:a], na.rm = TRUE), 4)
}

#' Heatmap of all plates
#'
#' Put all individual plates in one graph, values are the readout in experiments.
#'
#' @param dta synthetic lethal RNAi screen data
#' @param base_size basic font size used for x/y axis and title for heatmaps
#' @param heatmap_col color function generated by colorRampPalette.
#' @return a ggplot object
#' @examples
#' data(example_dt)
#' plateHeatmap(example_dt)
#' @export
plateHeatmap <- function(dta, base_size = 12, heatmap_col = NULL) {
  COL_NAME <- new_name <- PLATE <- EXPERIMENT_MODIFICATION <- ROW_NAME <- value <- NULL

  dta_2 <- copy(dta) %>%
    .[, new_name := paste(PLATE, EXPERIMENT_MODIFICATION, sep = " ")] %>%
    melt(id.vars = c("ROW_NAME", "COL_NAME", "new_name"), measure.vars = "READOUT") %>%
    .[, ROW_NAME := factor(ROW_NAME, levels = unique(ROW_NAME) %>% sort %>% rev)] %>%
    .[, COL_NAME := factor(COL_NAME, levels = unique(COL_NAME) %>% as.numeric %>% sort %>% rev %>% as.character)]

  if (is.null(heatmap_col)) heatmap_col <- colorRampPalette(rev(RColorBrewer::brewer.pal(11, "Spectral")))

  ggplot(as.data.frame(dta_2), aes(COL_NAME, ROW_NAME)) +
    geom_tile(aes(fill = value), colour = "white") +
    scale_fill_gradientn(colours = heatmap_col(100)) +
    theme_bw() +
    facet_wrap(~ new_name) +
    theme(axis.text.x = element_text(size = base_size * 0.5),
          axis.text.y = element_text(size = base_size * 0.5),
          plot.title  = element_text(size = base_size * 0.8),
          panel.grid.major = element_blank(),
          panel.grid.minor = element_blank(),
          panel.background = element_rect(colour = "black", size = 1)) +
    labs(x = "", y = "") +
    coord_equal() +
    #- Expand not working.
    # scale_x_continuous(expand = c(0, 0)) +
    theme(panel.background = element_rect(fill = "white", colour = "white"))
}

#' Synthetic lethal RNAi screen example data.
#'
#' A dataset containing synthetic lethal RNAi screen data to show how functions work.
#' The variables are as follows (all are character except READOUT):
#'
#' \itemize{
#'   \item PLATE. plate names.
#'   \item MASTER_PLATE. master plate names.
#'   \item WELL_CONTENT_NAME. siRNA targets of wells.
#'   \item EXPERIMENT_TYPE. sample, negative/positive controls.
#'   \item EXPERIMENT_MODIFICATION. experiment conditions, "treatment" or "control".
#'   \item ROW_NAME. row names of plates.
#'   \item COL_NAME. column names of plates.
#'   \item READOUT. screen results.
#' }
#'
#' @docType data
#' @keywords datasets
#' @name example_dt
#' @usage data(example_dt)
#' @format A data.table with 4320 rows and 8 variables
#' @return A data.table containing RANi screen data, the READOUT value has no real biological meaning.
NULL

#' Calculate B-score
#'
#' Calculate the B-score for plates belonging to the same master plate.
#' Positive / negative controls are removed from the calculation.
#'
#' @param masterPlate a maste plate to be normalized.
#' @param dta synthetic lethal RNAi screen data.
#' @param treatment the treatment experiment condition in EXPERIMENT_MODIFICATION
#' @param control the control experiment condition in EXPERIMENT_MODIFICATION.
#' @param outFile should calculated B-score files be written to the current folder? File names is (masterPlate).bscore.csv.
#' @return A list contains B-score for each master plate, treatment plates are the
#'   first columns, followed by control plates
#' @references
#' Brideau, C., Gunter, B., Pikounis, B. & Liaw, A. Improved statistical methods for hit selection in high-throughput screening. J. Biomol. Screen. 8, 634-647 (2003).
#' @examples
#' data(example_dt)
#' res <- sapply(unique(example_dt$MASTER_PLATE), bScore, example_dt,
#'               treatment = "treatment", control = "control", simplify = FALSE)
#' @export
bScore <- function(masterPlate, dta, treatment, control, outFile = FALSE) {
  MASTER_PLATE <- EXPERIMENT_MODIFICATION <- PLATE <- NULL

  contPlate  <- dta[MASTER_PLATE == masterPlate & EXPERIMENT_MODIFICATION == control, unique(PLATE)]
  treatPlate <- dta[MASTER_PLATE == masterPlate & EXPERIMENT_MODIFICATION == treatment, unique(PLATE)]

  b_cont  <- sapply(contPlate, .ff_bscorePlate, dta)
  b_treat <- sapply(treatPlate, .ff_bscorePlate, dta)

  b_cominbed <- NA

  if (! identical(rownames(b_treat), rownames(b_cont))) {
    message("(!!) Differernt order between and treatment and control in master plate: ", masterPlate, "\n")
  } else {
    b_cominbed <- cbind(b_treat, b_cont)
  }

  if (outFile && !is.na(b_cominbed)) {
    write.table(b_cominbed, paste0(masterPlate, ".bscore.csv"), sep = "\t", quote = FALSE)
  }

  return(b_cominbed)
}

#' @keywords internal
.ff_bscorePlate <- function(plateName, dta) {
  #- Internal function to calculate the B score;
  #- plateName, plate to be normalized;
  PLATE <- EXPERIMENT_TYPE <- NULL

  message("(II) Processing PLATE:", plateName, "\n")

  one_plate <- dta[PLATE == plateName & EXPERIMENT_TYPE == "sample"]

  norm_res <- dcast(one_plate, ROW_NAME ~ COL_NAME, value.var = "READOUT") %>%
    as.data.frame %>%
    set_rownames(as.character(.$ROW_NAME)) %>%
    inset("ROW_NAME", value = NULL) %>%
    as.matrix %>%
    medpolish(na.rm = TRUE, maxiter = 100)

  res <- (norm_res$residuals / mad(norm_res$residuals, na.rm = TRUE)) %>% c

  well_name <- dcast(one_plate, ROW_NAME ~ COL_NAME, value.var = "WELL_CONTENT_NAME") %>%
    as.data.frame %>%
    set_rownames(as.character(.$ROW_NAME)) %>%
    inset("ROW_NAME", value = NULL) %>%
    as.matrix %>%
    c

  if (sum(is.na(well_name)) == 0) {
    names(res) <- well_name
  }
  else {
    message("(!!) Wrong well names in plate: ", plateName)
  }

  return(res)
}

#' Select hits basing on median +- k*MAD
#'
#' Select hits basing on median +- k*MAD, by default k is three.
#'
#' @param masterPlate the master plate to analysis
#' @param dat synthetic lethal RNAi screen data
#' @param k cutoff for selecting hits, default is three
#' @param treatment the treatment condition in EXPERIMENT_MODIFICATION
#' @param control the control condition in EXPERIMENT_MODIFICATION
#' @param outFile whether or not write the median normalized results
#' @param normMethod normalization methods to be used. If "PLATE", the raw readouts are normalized by plate median, otherwise use median provided control siRNA.
#' @return A data.frame contains the hits selection results.
#' \itemize{
#'   \item MASTER_PLATE: location of siRNA
#'   \item treat_cont_ratio: ratio of treatment / control
#'   \item treat_median: median value of treatment plates
#'   \item control_median: median value of control plates
#'   \item Hits: Is this siRNA a hit?
#' }
#' @references
#' Chung,N.etal. Median absolute deviation to improve hits election for genome-scale RNAi screens. J. Biomol. Screen. 13, 149-158 (2008).
#' @examples
#' data(example_dt)
#' res <- sapply((unique(example_dt$MASTER_PLATE)),
#'               madSelect,
#'               example_dt,
#'               control   = "control",
#'               treatment = "treatment",
#'               simplify  = FALSE)
#' @export
madSelect <- function(masterPlate, dat, k = 3, treatment, control, outFile = FALSE, normMethod = "PLATE") {
  norm_res      <- .ff_masterPlateValue(masterPlate, dat, treatment, control, normMethod = normMethod)
  masterp_dta   <- norm_res[[1]]
  n_treat_plate <- norm_res[[2]]

  #- All plate belongs to the same master plate are concatenate together.
  if (outFile) {
    write.table(masterp_dta, paste0(masterPlate, ".median.norm.txt"), quote = FALSE, sep = "\t")
  }

  plate_ratio    <- t(apply(masterp_dta, 1, .ff_ratio_madS, n_treat_plate, n_treat_plate + 1))
  plate_r_med    <- median(plate_ratio[, 1])
  Hits           <- rep("No", nrow(plate_ratio))
  Hit_sele       <- (plate_ratio[, 1] < (plate_r_med - k * mad(plate_ratio[, 1])))
  Hits[Hit_sele] <- "Yes"

  res <- data.frame(MASTER_PLATE = masterPlate, plate_ratio, Hits = Hits)
}

#' @keywords internal
.ff_ratio_madS <- function(x, y, z) {
  a           <- length(x)
  med_treat   <- median(x[1:y], na.rm = TRUE)
  med_cont    <- median(x[z:a], na.rm = TRUE)
  tr_co_ratio <- med_treat / med_cont

  l <- c(tr_co_ratio, med_treat, med_cont)
  names(l) <- c("treat_cont_ratio", "treat_median", "control_median")
  return(l)
}

context("Test median +- k*MAD")

test_that("Correct calculation of median +- k*MAD", {
  res <- madSelect("P001", example_dt, control = "control", treatment = "treatment")
  expect_equal(as.numeric(res[1, 2:4]), c(0.9427558, 1.0201578, 1.0821018), tolerance = 1e-3)
  expect_equal(rownames(res)[1], "A2M si1")
})

#' Calcualte the Z and Z' factor
#'
#' calcualte the Z and Z' factor for each plate.
#'
#' @param dta synthetic lethal RNAi screen data.
#' @param negativeCon the negative control used in the WELL_CONTENT_NAME.
#' @param positiveCon the positive control used in the WELL_CONTENT_NAME.
#' @param useMean use mean to calcualate z factor and z' factor by default; otherwise use median.
#' @return  A data.frame contains z factor and z' factor
#' @examples
#' data(example_dt)
#' res <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1")
#' @references
#' Zhang J.H., Chung T.D. & Oldenburg K.R. A simple statistical parameter for use in evaluation and validation of high throughput screening assays. J. Biomol. Screen. B, 4 67-73 (1999).
#' Birmingham,A. et al. (2009) Statistical methods for analysis of high-throughput RNA interference screens. Nat Methods, 6, 569-575.
#' @export
zFactor <- function(dta, negativeCon, positiveCon, useMean = TRUE) {
  well_type <- WELL_CONTENT_NAME <- EXPERIMENT_TYPE <- READOUT <- PLATE <- NULL

  dta_2 <- copy(dta) %>%
    .[, well_type := WELL_CONTENT_NAME] %>%
    .[EXPERIMENT_TYPE == "sample", well_type := "treat"] %>%
    .[well_type %like% negativeCon, well_type := "neg_control"] %>%
    .[well_type %like% positiveCon, well_type := "posi_control"] %>%
    .[well_type %in% c("treat", "neg_control", "posi_control")]

  if (useMean) {
    dta_3 <- dta_2[, .(sd_value = sd(READOUT, na.rm = TRUE), m_value = mean(READOUT, na.rm = TRUE)), by = c("PLATE", "well_type", "EXPERIMENT_MODIFICATION")]
  } else {
    dta_3 <- dta_2[, .(sd_value = sd(READOUT, na.rm = TRUE), m_value = median(READOUT, na.rm = TRUE)), by = c("PLATE", "well_type", "EXPERIMENT_MODIFICATION")]
  }

  dta_sd <- dcast(dta_3, PLATE ~ well_type, value.var = "sd_value") %>% setnames(c(2:4), paste0("sd_", colnames(.)[2:4]))
  dta_m  <- dcast(dta_3, PLATE ~ well_type, value.var = "m_value") %>% setnames(c(2:4), paste0("m_", colnames(.)[2:4]))

  if(identical(dta_sd$PLATE, dta_m$PLATE)) {
    dta_all <- cbind(dta_sd, dta_m[, PLATE := NULL])
    mtx     <- as.matrix(dta_all[, PLATE := NULL]) %>% set_rownames(dta_sd$PLATE) %>% na.omit
    mtx     <- mtx[, c("sd_neg_control", "sd_posi_control", "sd_treat", "m_neg_control", "m_posi_control", "m_treat")]

    message("(II) Number of plates to calculate Z/Z' factor: ", nrow(mtx), "\n")

    res <- t(apply(mtx, 1, .ff_z)) %>% set_colnames(c("zFactor", "zPrimeFactor"))
  } else {
    message("(EE) Plate names for mean/median and sd are not paired!", "\n")
    res <- NULL
  }

  return(res)
}

#' @keywords internal
.ff_z <- function(x) {
  sd_nega  <- x[1]
  sd_posi  <- x[2]
  sd_treat <- x[3]
  m_nega   <- x[4]
  m_posi   <- x[5]
  m_treat  <- x[6]

  z_factor <- 1 - 3 * (sd_nega + sd_treat) / abs(m_nega - m_treat)
  z_primef <- 1 - 3 * (sd_nega + sd_posi) / abs(m_nega - m_posi)

  return(c(z_factor, z_primef))
}

context("Test calculation of z factor")

test_that("Correct calculation of z factor", {
  res <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1")
  expect_equal(as.numeric(res[1, ]), c(-10.634224, -41.363250), tolerance = 1e-3)
})

#- norm_method is either "PLATE" or siRNA to be used (e.g., "lipid only" in WELL_CONTENT_NAME)
#' @keywords internal
.ff_norm <- function(masterPlate, dta, norm_method = "PLATE") {
  WELL_CONTENT_NAME <- MASTER_PLATE <- EXPERIMENT_TYPE <- READOUT <- NORMEDV <- BACKGROUND_MED <- NULL

  masterp_dta <- dta[MASTER_PLATE == masterPlate & EXPERIMENT_TYPE == "sample" & WELL_CONTENT_NAME != "empty"]

  if (norm_method == "PLATE") {
    norm_dta <- masterp_dta[, .(BACKGROUND_MED = median(READOUT, na.rm = TRUE)), by = "PLATE"]
  } else {
    norm_dta <- dta[MASTER_PLATE == masterPlate & WELL_CONTENT_NAME == norm_method] %>%
      .[, .(BACKGROUND_MED = median(READOUT, na.rm = TRUE)), by = "PLATE"]
  }

  masterp_norm <- merge(masterp_dta, norm_dta, by.x = "PLATE", by.y = "PLATE", all.x = TRUE) %>%
    .[, NORMEDV := READOUT / BACKGROUND_MED]

  return(masterp_norm)
}

#- normMethod is either "PLATE", or contron siRNA names. Former is prefered.
#' @keywords internal
.ff_masterPlateValue <- function(masterPlate, dta, treatment, control, normMethod = "PLATE") {
  EXPERIMENT_MODIFICATION <- PLATE <- NULL

  masterp_dta <- .ff_norm(masterPlate, dta, normMethod)

  treat_p <- masterp_dta[EXPERIMENT_MODIFICATION == treatment, unique(PLATE)]
  cont_p  <- masterp_dta[EXPERIMENT_MODIFICATION == control, unique(PLATE)]

  if (length(treat_p) != 0 & length(cont_p) != 0) {
    ## treatment first, followed by controls;
    plate_paired <- c(treat_p, cont_p)
    masterp_dta_w <- dcast(masterp_dta, WELL_CONTENT_NAME ~ PLATE, value.var = "NORMEDV") %>%
      as.data.frame %>%
      set_rownames(.$WELL_CONTENT_NAME) %>%
      inset("WELL_CONTENT_NAME", value = NULL) %>%
      extract(, plate_paired)

    master_norm <- list(normedV = masterp_dta_w, n_treat_plate = length(treat_p), n_cont_plate = length(cont_p))
  } else {
    stop("(EE) Empty control or treament plates in master plate:", masterPlate, "\n")
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scatterPlot.R
\name{scatterPlot}
\alias{scatterPlot}
\title{Scatter plot of RNAi screen results}
\usage{
scatterPlot(
  dta,
  scatter_colour = rainbow(10),
  controlOnly = FALSE,
  control_name = NULL
)
}
\arguments{
\item{dta}{synthetic lethal RNAi screen data}

\item{scatter_colour}{colour for different signals}

\item{controlOnly}{whether or not to plot control wells only}

\item{control_name}{names of control siRNAs.}
}
\value{
a ggplot object
}
\description{
Produce a single plot for readous of each plate, with the option of highlighting
specific signals, like positive/negative controls.
}
\examples{
data(example_dt)
scatterPlot(example_dt, control_name = c("PLK1 si1", "scrambled control si1", "lipid only"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tTest.R
\name{tTest}
\alias{tTest}
\title{student's t-test on B-score}
\usage{
tTest(mtx, n_treat, n_cont)
}
\arguments{
\item{mtx}{b-score matrix.}

\item{n_treat}{number of treatment plates}

\item{n_cont}{number of control plates}
}
\value{
A list containing student's t-test for each master plate
\itemize{
  \item pvalue: p-value of the t-test
  \item Treat_Cont: difference in bscore: treatment - control
  \item p_adj: BH adjusted p-value
}
}
\description{
Select hits by student's t-test using B-score from treatment and control plates.
}
\examples{
data(example_dt)
bscore_res <- sapply(unique(example_dt$MASTER_PLATE), bScore,
  example_dt, control = "control", treatment = "treatment", simplify = FALSE)
tTest(bscore_res$P001, 3, 3)
}
\references{
Birmingham, A. et al. Statistical methods for analysis of high-throughput RNA interference screens. Nat Methods 6, 569-575 (2009).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bScore.R
\name{bScore}
\alias{bScore}
\title{Calculate B-score}
\usage{
bScore(masterPlate, dta, treatment, control, outFile = FALSE)
}
\arguments{
\item{masterPlate}{a maste plate to be normalized.}

\item{dta}{synthetic lethal RNAi screen data.}

\item{treatment}{the treatment experiment condition in EXPERIMENT_MODIFICATION}

\item{control}{the control experiment condition in EXPERIMENT_MODIFICATION.}

\item{outFile}{should calculated B-score files be written to the current folder? File names is (masterPlate).bscore.csv.}
}
\value{
A list contains B-score for each master plate, treatment plates are the
  first columns, followed by control plates
}
\description{
Calculate the B-score for plates belonging to the same master plate.
Positive / negative controls are removed from the calculation.
}
\examples{
data(example_dt)
res <- sapply(unique(example_dt$MASTER_PLATE), bScore, example_dt,
              treatment = "treatment", control = "control", simplify = FALSE)
}
\references{
Brideau, C., Gunter, B., Pikounis, B. & Liaw, A. Improved statistical methods for hit selection in high-throughput screening. J. Biomol. Screen. 8, 634-647 (2003).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/madSelect.R
\name{madSelect}
\alias{madSelect}
\title{Select hits basing on median +- k*MAD}
\usage{
madSelect(
  masterPlate,
  dat,
  k = 3,
  treatment,
  control,
  outFile = FALSE,
  normMethod = "PLATE"
)
}
\arguments{
\item{masterPlate}{the master plate to analysis}

\item{dat}{synthetic lethal RNAi screen data}

\item{k}{cutoff for selecting hits, default is three}

\item{treatment}{the treatment condition in EXPERIMENT_MODIFICATION}

\item{control}{the control condition in EXPERIMENT_MODIFICATION}

\item{outFile}{whether or not write the median normalized results}

\item{normMethod}{normalization methods to be used. If "PLATE", the raw readouts are normalized by plate median, otherwise use median provided control siRNA.}
}
\value{
A data.frame contains the hits selection results.
\itemize{
  \item MASTER_PLATE: location of siRNA
  \item treat_cont_ratio: ratio of treatment / control
  \item treat_median: median value of treatment plates
  \item control_median: median value of control plates
  \item Hits: Is this siRNA a hit?
}
}
\description{
Select hits basing on median +- k*MAD, by default k is three.
}
\examples{
data(example_dt)
res <- sapply((unique(example_dt$MASTER_PLATE)),
              madSelect,
              example_dt,
              control   = "control",
              treatment = "treatment",
              simplify  = FALSE)
}
\references{
Chung,N.etal. Median absolute deviation to improve hits election for genome-scale RNAi screens. J. Biomol. Screen. 13, 149-158 (2008).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/siRNAPlot.R
\name{siRNAPlot}
\alias{siRNAPlot}
\title{Plot siRNA data and quality metrics.}
\usage{
siRNAPlot(
  gene,
  dta,
  controlsiRNA,
  FILEPATH = ".",
  colour = rainbow(10),
  zPrimeMed,
  zPrimeMean,
  treatment,
  control,
  normMethod = c("PLATE"),
  save_plot = FALSE,
  width = 15,
  height = 14
)
}
\arguments{
\item{gene}{gene symbol, case sensitive}

\item{dta}{synthetic lethal RNAi screen data}

\item{controlsiRNA}{controlsiRNA could be a vector of several siRNA, including postive/negative control}

\item{FILEPATH}{path to store the figure}

\item{colour}{colour used in graphs}

\item{zPrimeMed}{zPrime factor basing on median}

\item{zPrimeMean, }{zPrime factor basing on mean}

\item{treatment}{the treatment condition in EXPERIMENT_MODIFICATION}

\item{control}{the control condition in EXPERIMENT_MODIFICATION}

\item{normMethod}{could be a PLATE and negative controls}

\item{save_plot}{whether save a png file in the working directory.}

\item{width}{width of the plot}

\item{height}{height of the plot}
}
\value{
Return the ggplot2 objects in a list, which could be plotted individually.
}
\description{
Plot the normalized RNAi screen data, row data, control signals and Z' factor.
}
\examples{
data(example_dt)
zF_mean <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1")
zF_med  <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1",
                   useMean = FALSE)
p01 <- siRNAPlot("AAK1", example_dt,
                 controlsiRNA = c("lipid only", "scrambled control si1"),
                 FILEPATH = ".",  zPrimeMed = zF_med, zPrimeMean = zF_mean,
                 treatment = "treatment", control = "control",
                 normMethod = c("PLATE", "lipid only", "scrambled control si1"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{example_dt}
\alias{example_dt}
\title{Synthetic lethal RNAi screen example data.}
\format{
A data.table with 4320 rows and 8 variables
}
\usage{
data(example_dt)
}
\value{
A data.table containing RANi screen data, the READOUT value has no real biological meaning.
}
\description{
A dataset containing synthetic lethal RNAi screen data to show how functions work.
The variables are as follows (all are character except READOUT):
}
\details{
\itemize{
  \item PLATE. plate names.
  \item MASTER_PLATE. master plate names.
  \item WELL_CONTENT_NAME. siRNA targets of wells.
  \item EXPERIMENT_TYPE. sample, negative/positive controls.
  \item EXPERIMENT_MODIFICATION. experiment conditions, "treatment" or "control".
  \item ROW_NAME. row names of plates.
  \item COL_NAME. column names of plates.
  \item READOUT. screen results.
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rsaHits.R
\name{rsaHits}
\alias{rsaHits}
\title{Select hits by RSA}
\usage{
rsaHits(
  dta,
  treatment,
  control,
  normMethod = "PLATE",
  LB,
  UB,
  revHits = FALSE,
  Bonferroni = FALSE,
  outputFile = "RSAhits.csv",
  scoreFile = "RSA_score.csv"
)
}
\arguments{
\item{dta}{synthetic lethal RNAi screen data}

\item{treatment}{the treatment condition in EXPERIMENT_MODIFICATION}

\item{control}{the control condition in EXPERIMENT_MODIFICATION}

\item{normMethod}{normalization methods. If "PLATE", then values are normalized by plate median, otherwise use the
provided control siRNA}

\item{LB}{Low bound}

\item{UB}{up bound}

\item{revHits}{reverse hit picking, default the lower the score the better}

\item{Bonferroni}{conceptually useful when there are different number of siRNAs per gene, default FALSE}

\item{outputFile}{output file name}

\item{scoreFile}{name of the score file to be written under the current folder}
}
\value{
A result file written to the current folder.
\itemize{
  \item Gene_ID,Well_ID,Score: columns from input spreadsheet
  \item LogP: OPI p-value in log10, i.e., -2 means 0.01
  \item OPI_Hit: whether the well is a hit, 1 means yes, 0 means no
  \item #hitWell: number of hit wells for the gene
  \item #totalWell: total number of wells for the gene. If gene A has three wells w1, w2 and w3, and w1 and w2 are hits, #totalWell should be 3, #hitWell should be 2, w1 and w2 should have OPI_Hit set as 1 and w3 should have OPI_Hit set as 0.
  \item OPI_Rank: ranking column to sort all wells for hit picking
  \item Cutoff_Rank: ranking column to sort all wells based on Score in the simple activity-based method
}
Note: a rank value of 999999 means the well is not a hit
}
\description{
Selected hits by redundant siRNA activity method. Here is a wrapper function of RSA 1.8 by Yingyao Zhou.
}
\examples{
data(example_dt)
rsaHits(example_dt, treatment = "treatment", control = "control",
        normMethod = "PLATE", LB = 0.2, UB = 0.8, revHits = FALSE,
        Bonferroni = FALSE, outputFile = "RSAhits.csv")
}
\references{
Koenig, R. et al. A probability-based approach for the analysis of large-scale RNAi screens. Nat Methods 4, 847-849 (2007).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plateHeatmap.R
\name{plateHeatmap}
\alias{plateHeatmap}
\title{Heatmap of all plates}
\usage{
plateHeatmap(dta, base_size = 12, heatmap_col = NULL)
}
\arguments{
\item{dta}{synthetic lethal RNAi screen data}

\item{base_size}{basic font size used for x/y axis and title for heatmaps}

\item{heatmap_col}{color function generated by colorRampPalette.}
}
\value{
a ggplot object
}
\description{
Put all individual plates in one graph, values are the readout in experiments.
}
\examples{
data(example_dt)
plateHeatmap(example_dt)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zFactor.R
\name{zFactor}
\alias{zFactor}
\title{Calcualte the Z and Z' factor}
\usage{
zFactor(dta, negativeCon, positiveCon, useMean = TRUE)
}
\arguments{
\item{dta}{synthetic lethal RNAi screen data.}

\item{negativeCon}{the negative control used in the WELL_CONTENT_NAME.}

\item{positiveCon}{the positive control used in the WELL_CONTENT_NAME.}

\item{useMean}{use mean to calcualate z factor and z' factor by default; otherwise use median.}
}
\value{
A data.frame contains z factor and z' factor
}
\description{
calcualte the Z and Z' factor for each plate.
}
\examples{
data(example_dt)
res <- zFactor(example_dt, negativeCon = "scrambled control si1", positiveCon = "PLK1 si1")
}
\references{
Zhang J.H., Chung T.D. & Oldenburg K.R. A simple statistical parameter for use in evaluation and validation of high throughput screening assays. J. Biomol. Screen. B, 4 67-73 (1999).
Birmingham,A. et al. (2009) Statistical methods for analysis of high-throughput RNA interference screens. Nat Methods, 6, 569-575.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rankProdHits.R
\name{rankProdHits}
\alias{rankProdHits}
\title{Select hits by the rank product method}
\usage{
rankProdHits(masterPlate, dta, treatment, control, normMethod = "PLATE")
}
\arguments{
\item{masterPlate}{the master plate to be analyzed}

\item{dta}{synthetic lethal RNAi screen data}

\item{treatment}{the treatment condition in EXPERIMENT_MODIFICATION}

\item{control}{the control condition in EXPERIMENT_MODIFICATION}

\item{normMethod}{normalization methods to be used. If "PLATE", the raw readouts are normalized by plate median, otherwise use provided control siRNA}
}
\value{
A list contains results by the rank product method for each master plate.
\itemize{
  \item MASTER_PLATE: location of siRNA
  \item pvalue_treat_lowerthan_cont: p-value for the hypothesis that treatment has lower normalized readout compared to control
  \item FDR_treat_lowerthan_cont: FDR value
  \item treat_cont_log2FC: log2 fold change of treatment / control
}
}
\description{
Select hits by rank product methods by comparing treatment and control.
}
\examples{
data(example_dt)
res <- sapply(unique(example_dt$MASTER_PLATE),
              rankProdHits,
              example_dt,
              control   = "control",
              treatment = "treatment",
              simplify  = FALSE)
}
\references{
Breitling, R., Armengaud, P., Amtmann, A. & Herzyk, P. Rank products: a simple, yet powerful, new method to detect differentially regulated genes in replicated microarray experiments. FEBS Lett 573, 83-92 (2004).
Hong, F. et al. RankProd: a bioconductor package for detecting differentially expressed genes in meta-analysis. Bioinformatics 22, 2825-2827 (2006).
}
